<template>
  <el-row
    v-if="parameters"
    id="tour-parameters-component"
    style="margin-bottom: 3%"
  >
    <el-card style="background-color: #f2f6fc">
      <el-row
        style="flex-wrap: wrap"
        type="flex"
        justify="space-between"
        :gutter="50"
      >
        <el-col
          style="margin-bottom: 1%"
          :xl="4"
          :lg="7"
          :md="12"
          :sm="12"
          :xs="24"
          :key="index"
          v-for="(period, index) in parameters.periods"
          v-loading="isLoading"
        >
          <el-card>
            <el-row style="margin-bottom: 3%">
              <el-tooltip
                :enterable="false"
                content="Начало и конец недельного периода"
                placement="bottom"
                effect="light"
              >
                <el-date-picker
                  class="tour-date-picker-element"
                  @change="onPeriodChanged(period)"
                  size="mini"
                  type="daterange"
                  format="dd.MM.yyyy"
                  v-model="period.periods"
                  start-placeholder="Начало"
                  end-placeholder="Конец"
                  :picker-options="{ firstDayOfWeek: 1 }"
                />
              </el-tooltip>
            </el-row>
            <el-row style="margin-bottom: 3%">
              <el-tooltip
                :enterable="false"
                content="Инвентарь периода"
                placement="bottom"
                effect="light"
              >
                <el-input
                  class="tour-inventory-element"
                  @input="onInventoryInputChange(period)"
                  placeholder="Инвентарь"
                  style="width: 100%"
                  size="mini"
                  v-model="period.inventory"
                  clearable
                />
              </el-tooltip>
            </el-row>
            <el-row style="margin-bottom: 3%">
              <el-tooltip
                :enterable="false"
                content="Процент Prime [0 - 0%, 50 - 50%, 100 - 100%]"
                placement="bottom"
                effect="light"
              >
                <el-input-number
                  class="tour-prime-percent-element"
                  placeholder="% Prime"
                  style="width: 100%"
                  size="mini"
                  v-model="period.percentPrime"
                  @change="onPrimeChanged"
                  :max="100"
                  :step="5"
                  :min="0"
                />
              </el-tooltip>
            </el-row>
            <el-divider />
            <el-card
              :id="`tour-film-component-${index}`"
              v-loading="period.fromDate == null && period.beforeDate == null"
              shadow="hover"
              style="margin-bottom: 1.5%"
              :key="film.linkID"
              v-for="(film, index) in period.filteredFilms"
            >
              <div slot="header">
                <el-tooltip
                  class="item"
                  effect="light"
                  :content="`${film.duration}' ${film.versionName}`"
                  placement="top-start"
                >
                  <div style="font-size: 10px; color: #909399">
                    {{ film.duration }}'
                    {{ truncateFilmName(film.versionName) }}
                  </div>
                </el-tooltip>
              </div>
              <el-tooltip
                :enterable="false"
                content="Процент от инвентаря периода [0 - 0%, 50 - 50%, 100 - 100%]"
                placement="bottom"
                effect="light"
              >
                <el-input-number
                  style="align-self: center; width: 100%"
                  size="mini"
                  placeholder="% от инвентаря периода"
                  v-model="film.inventoryPercent"
                  @change="onFilmInventoryChange(period, film)"
                  :max="100"
                  :step="5"
                  :min="0"
                />
              </el-tooltip>
            </el-card>
          </el-card>
        </el-col>
      </el-row>
      <el-divider />
      <el-row
        style="flex-wrap: wrap"
        type="flex"
        justify="space-between"
        :gutter="50"
      >
        <el-col
          style="margin-bottom: 1%"
          :xl="6"
          :lg="6"
          :md="12"
          :sm="12"
          :xs="24"
        >
          <el-card style="height: 100%">
            <el-row>
              <b>Указано инвентаря: </b>
              <span style="color: #67c23a">{{ totalInventory }}</span>
            </el-row>
            <el-row>
              <b>Указано инвентаря prime: </b>
              <span style="color: #409eff">{{ primeInventory }}</span>
            </el-row>
          </el-card>
        </el-col>
        <el-col
          style="margin-bottom: 1%"
          :xl="6"
          :lg="6"
          :md="12"
          :sm="12"
          :xs="24"
        >
          <el-card style="height: 100%">
            <el-form size="mini" @submit.native.prevent>
              <RatingPlacementTypeComponent :event-bus="eventBus" />
              <SwitchComponent :event-bus="eventBus" />
              <PercentInventoryNeed :event-bus="eventBus" />
            </el-form>
          </el-card>
        </el-col>
      </el-row>
    </el-card>
  </el-row>
</template>

<script lang="ts">
import { Component, Mixins } from "vue-property-decorator";
import { MediaPlan } from "@/interfaces/MediaPlan";
import ComponentMixin from "@/components/common/ComponentMixin";
import { MediaPlanParameters } from "@/interfaces/parameters/MediaPlanParameters";
import { MediaPlanParametersPeriod } from "@/interfaces/parameters/MediaPlanParametersPeriod";
import SwitchComponent from "@/components/media-plan-parameters-view/SwitchComponent.vue";
import PercentInventoryNeed from "@/components/media-plan-parameters-view/PercentInventoryNeed.vue";
import RatingPlacementTypeComponent from "@/components/media-plan-parameters-view/RatingPlacementTypeComponent.vue";
import { MediaPlanParametersPeriodFilm } from "@/interfaces/parameters/MediaPlanParametersPeriodFilm";

@Component({
  components: {
    RatingPlacementTypeComponent,
    SwitchComponent,
    PercentInventoryNeed,
  },
})
export default class WeeksComponent extends Mixins(ComponentMixin) {
  private isPrimeAlreadyChanged = false;
  private isLoading = true;

  private parameters: null | MediaPlanParameters = null;

  private filteredFilms = false;

  /**
   * Медиаплан.
   */
  private mediaPlan: null | MediaPlan = null;

  /**
   * Вычисляемое свойство "всего указано инвентаря".
   *
   * @return {number} значение всего указано инвентаря.
   */
  get totalInventory(): string {
    if (!this.parameters) return "0";
    return this.parameters.periods
      .reduce((a, period) => {
        if (typeof period.inventory === "number") {
          return a + period.inventory;
        } else if (isNaN(parseFloat(period.inventory))) {
          return a;
        } else {
          return a + parseFloat(period.inventory);
        }
      }, 0)
      .toFixed(3);
  }

  /**
   * Вычисляемое свойство "указано инвентаря prime".
   *
   * @return {number} значение указано инвентаря prime.
   */
  get primeInventory(): string {
    if (!this.parameters) return "0";
    return this.parameters?.periods
      .reduce((a, period) => {
        if (typeof period.inventory === "number") {
          return a + period.inventory * (period.percentPrime / 100);
        } else if (isNaN(parseFloat(period.inventory))) {
          return a;
        } else {
          return a + parseFloat(period.inventory) * (period.percentPrime / 100);
        }
      }, 0)
      .toFixed(3);
  }

  protected created(): void {
    this.subscribeAll([
      // Подписываемся на событие получения информации о медиаплане
      ["media-plan-response", this.onMediaPlanResponse],
      // Подписываемся на событие получения параметров автоматической расстановки медиаплана
      ["media-plan-parameters-response", this.onMediaPlanParametersResponse],
      // Подписываемся на события срабатывания "switch компонента" фильтрации по сплитам
      ["option-filtered-on-off", this.onOffFilteredFilms],
    ]);
  }

  /**
   * Метод срабатывает после переключения switch компонента.
   */
  private onOffFilteredFilms(onOffFiltered: boolean) {
    this.parameters?.periods.forEach((value) =>
      value.filterFilms(onOffFiltered)
    );
    this.filteredFilms = onOffFiltered;
  }

  /**
   * Метод срабатывает после получения информации о медиаплане.
   * @param {MediaPlan} mediaPlan медиаплан.
   */
  private onMediaPlanResponse(mediaPlan: MediaPlan): void {
    // Сохраняем медиаплан в переменную
    this.mediaPlan = mediaPlan;
  }

  private onPrimeChanged(newValue: number) {
    if (this.isPrimeAlreadyChanged) return;
    this.isPrimeAlreadyChanged = true;
    this.parameters?.periods.forEach((x) => (x.percentPrime = newValue));
  }

  /**
   * Метод срабатывает после получения параметров автоматической расстановки медиаплана.
   *
   * @param {MediaPlanParameters} parameters параметры автоматической расстановки медиаплана.
   */
  private onMediaPlanParametersResponse(parameters: MediaPlanParameters): void {
    parameters.periods = parameters.periods.sort((a, b) => {
      const k = a.fromDate ? new Date(a.fromDate) : 99999999999999999;
      const j = b.fromDate ? new Date(b.fromDate) : 99999999999999999;
      return k > j ? 1 : k < j ? -1 : 0;
    });

    this.parameters = parameters;

    this.parameters.periods.forEach((period) =>
      period.filterFilms(this.filteredFilms)
    );

    // Отключаем индикатор загрузки
    setTimeout(() => {
      this.isLoading = false;
    }, 200);
    this.$nextTick(() => {
      this.notify(
        "media-plan-parameters-response-from-parent",
        this.parameters
      );
    });
  }

  /**
   * Метод срабатывает после изменения инвентаря в периоде параметров автоматического размещения медиаплана. В методе
   * происходит фильтрация и нормализация введённых значений.
   * @param {MediaPlanParametersPeriod} period период параметров автоматического размещения медиаплана.
   */
  private onInventoryInputChange(period: MediaPlanParametersPeriod): void {
    // Нормализуем и предотвращаем ввод нежелательных символов в поле
    period.inventory = this.filterAndNormalizeFloatingValue(
      period.inventory.toString()
    );
  }

  /**
   * Метод нормализации значения с плавающей точкой.
   *
   * @param {string} stringifyValue вводимое в поле значение с плавающей точкой в строковом представлении.
   * @return {string} отфильтрованное и нормализированное значение с плавающей точкой.
   */
  private filterAndNormalizeFloatingValue(stringifyValue: string): string {
    // Если значение не является: [".", ",", "0"] - возвращаем действительную строку
    if (
      stringifyValue.length == 1 &&
      [".", ",", "0"].indexOf(stringifyValue.charAt(0)) != -1
    ) {
      stringifyValue = stringifyValue = "0.";
    }
    // Иначе возвращаем нормализированную строку
    return stringifyValue
      .replace(/[^0-9.,]/g, "")
      .replace("/(\\,,*)\\,/g", "$1")
      .replace(",", ".")
      .replace(/(\..*)\./g, "$1");
  }

  /**
   * Метод вызывается после изменения периода.
   * @param {MediaPlanParametersPeriod} period период, который изменился.
   */
  private onPeriodChanged(period: MediaPlanParametersPeriod): void {
    if (!period.periods) {
      period.fromDate = null;
      period.beforeDate = null;
    } else if (period.periods[0] && period.periods[1]) {
      period.fromDate = period.periods[0];
      period.beforeDate = period.periods[1];
    }
    period.filterFilms(this.filteredFilms);
  }

  private onFilmInventoryChange(
    period: MediaPlanParametersPeriod,
    film: MediaPlanParametersPeriodFilm
  ) {
    const otherFilms = period.filteredFilms.filter((x) => x.id != film.id);
    if (otherFilms.length == 1) {
      otherFilms[0].inventoryPercent = 100 - film.inventoryPercent;
    }
  }

  /**
   * Метод сжатия названия ролика.
   * @param {string} name название ролика.
   */
  private truncateFilmName(name: string): string {
    return name.length <= 28 ? name : name.substring(0, 25) + "...";
  }
}
</script>

<style lang="scss">
.el-date-editor {
  width: 100% !important;
}

.el-range-editor--mini .el-range-input {
  font-size: 11px !important;
}
</style>
